#include <vcl.h>
#pragma hdrstop
#include "FrmSetup.h"
#include "../kbtim/kbstr.h"
#include "../kbtim/kbini.h"

#pragma resource "*.dfm"
TSetupForm *SetupForm;
//---------------------------------------------------------------------------
enum {
	RESAMPLE_CSPLINE,  //0 = C XvC
	RESAMPLE_LAGRANGE, //1 = OW
	RESAMPLE_GAUSS,    //2 = KEX(ftHg)
	RESAMPLE_NEWTON,   //3 = j[g
	RESAMPLE_LINEAR,   //4 = `
	RESAMPLE_NONE      //5 = Ȃ
};

static const char* __fastcall kbGetAppPath(void);
static void __fastcall kbGetFileTimeFromFileName(const char *cszFileName, FILETIME *pft);
static void __fastcall ExecExplorer(const char* cszPath);
static void __fastcall GetIniFileNameFromTemplateName(const char *cszTemplateName, char *pszIniFile, int nSize);
static void __fastcall GetKpiFileNameFromTemplateName(const char *cszTemplateName, char *pszKpiFile, int nSize);

static const char* __fastcall kbGetAppPath(void)
{
    static char szAppPath[MAX_PATH*2];
    if(!szAppPath[0]){
        char szAppName[MAX_PATH*2];
        GetModuleFileName(NULL, szAppName, sizeof(szAppName));
        kbExtractFilePath(szAppPath, szAppName, sizeof(szAppPath));
    }
    return szAppPath;
}
static void __fastcall kbGetFileTimeFromFileName(const char *cszFileName, FILETIME *pft)
{
    pft->dwHighDateTime = pft->dwLowDateTime = 0;
    HANDLE hFile = CreateFile(cszFileName,
                              GENERIC_READ,
                              FILE_SHARE_READ|FILE_SHARE_WRITE,
                              NULL,
                              OPEN_EXISTING,
                              FILE_ATTRIBUTE_NORMAL,
                              NULL);
    if(hFile != INVALID_HANDLE_VALUE){
        GetFileTime(hFile, NULL, NULL, pft);
        CloseHandle(hFile);
    }
}
static bool __fastcall kbFileExists(const char *cszName)
{
    DWORD dwCode = GetFileAttributes(cszName);
    if(dwCode != 0xffffffff){
        if(!(FILE_ATTRIBUTE_DIRECTORY & dwCode)){
            return true;
        }
    }
    return false;
}
static void __fastcall ExecExplorer(const char* cszPath)
{//cszPath  Windows GNXv[ŊJ
 //cszPath t@C̏ꍇ cszPath ݂tH_J
    char szParam[MAX_PATH*2];
    char szExplorer[MAX_PATH*2];
    char szPath[MAX_PATH*2];
    if(kbFileExists(cszPath)){
    //t@C݂ꍇAt@C݂tH_J
        kbExtractFilePath(szPath, cszPath, sizeof(szPath));
    }
    else{
        kbStrLCpy(szPath, cszPath, sizeof(szPath));
    }
    kbStrLCpy(szParam, "/e,", sizeof(szParam));
    kbStrLCat(szParam, "\"", sizeof(szParam));
    kbStrLCat(szParam, szPath, sizeof(szParam));
    kbStrLCat(szParam, "\"", sizeof(szParam));

    GetWindowsDirectory(szExplorer, sizeof(szExplorer));
    kbStrLCat(szExplorer, "\\Explorer.exe", sizeof(szExplorer));
    ShellExecute(NULL, "open", szExplorer, szParam, NULL, SW_SHOWNORMAL);
}
static void __fastcall GetIniFileNameFromTemplateName(const char *cszTemplateName, char *pszIniFile, int nSize)
{//ev[g  INI t@C擾
 //cszTemplateName == "Default" ̏ꍇAINI t@C kbtim.ini ɂȂ
 //ȊȌꍇ kbtim_TemplateName.ini ɂȂ
    static const char cszKbtim[] = "kbtim";
    static const char cszIni[] = ".ini";
    kbStrLCpy(pszIniFile, kbGetAppPath(), nSize);
    kbStrLCat(pszIniFile, cszKbtim, nSize);
    if(kbStrCmpI(cszTemplateName, "Default") != 0){
        kbStrLCat(pszIniFile, "_", nSize);
        kbStrLCat(pszIniFile, cszTemplateName, nSize);
    }
    kbStrLCat(pszIniFile, cszIni, nSize);
}
static void __fastcall GetKpiFileNameFromTemplateName(const char *cszTemplateName, char *pszKpiFile, int nSize)
{//KbSettingTimidity::szTemplateName  KPI t@C擾
 //cszTemplateName == "Default" ̏ꍇAKPI t@C kbtim.kpi ɂȂ
 //ȊȌꍇ kbtim_TemplateName.kpi ɂȂ
    static const char cszKbtim[] = "kbtim";
    static const char cszKpi[] = ".kpi";
    kbStrLCpy(pszKpiFile, kbGetAppPath(), nSize);
    kbStrLCat(pszKpiFile, cszKbtim, nSize);
    if(kbStrCmpI(cszTemplateName, "Default") != 0){
        kbStrLCat(pszKpiFile, "_", nSize);
        kbStrLCat(pszKpiFile, cszTemplateName, nSize);
    }
    kbStrLCat(pszKpiFile, cszKpi, nSize);
}
static void __fastcall ReadSetting(KbSettingTimidity *pSetting)
{
    char szIniFile[MAX_PATH*2];
    GetIniFileNameFromTemplateName(pSetting->szTemplateName, szIniFile, sizeof(szIniFile));
    pSetting->LoadSettings(szIniFile);
}
static void __fastcall WriteSetting(KbSettingTimidity *pSetting)
{
    char szIniFile[MAX_PATH*2];
    GetIniFileNameFromTemplateName(pSetting->szTemplateName, szIniFile, sizeof(szIniFile));
    pSetting->SaveSettings(szIniFile);
}
static BOOL __fastcall CheckTemplateName(char *szTemplateName)
{//ev[gǂׂ
 //ev[gvOCt@C܂̂ŁAt@CɎgpoȂ
 //̓ev[gɎgpoȂ
    static const char cszIllegal[] = "\\/:*?\"<>|";

    kbStrTrim(kbCRLFtoSpace(szTemplateName));
    if(!szTemplateName[0]){
        Application->MessageBox("ev[g͂ĉB", "G[", MB_OK);
        return FALSE;
    }
    if(kbStrCmpI(szTemplateName, "Default") == 0){
        Application->MessageBox("ev[g \"Default\" ͎gpł܂B", "G[", MB_OK);
        return FALSE;
    }
    const char *p = szTemplateName;
    while(*p){
        if(kbIsLeadByte(*p)){
            p += 2;
            continue;
        }
        int i;
        for(i = 0; cszIllegal[i]; i++){
            if(*p == cszIllegal[i]){
                char sz[256];
                wsprintf(sz, "ev[gɂ͈ȉ͎̕g܂B\r\n\r\n"
                             "%s", cszIllegal);
                Application->MessageBox(sz, "G[", MB_OK);
                return FALSE;
            }
        }
        p++;
    }
    return TRUE;
}

//---------------------------------------------------------------------------
__fastcall TSetupForm::TSetupForm(TComponent* Owner)
    : TForm(Owner)
{
    kbStr_Initialize();
    m_bChanging = TRUE;
    m_bModified = FALSE;
    m_bModified2 = FALSE;

    KbSettingTimidity *pSetting = new KbSettingTimidity;
    kbStrLCpy(pSetting->szTemplateName, "Default", sizeof(pSetting->szTemplateName));
    Edit->MaxLength = sizeof(pSetting->szTemplateName) - 2;
    Memo->MaxLength = sizeof(pSetting->ConfigFile) - 2;
    TreeView->Items->Add(NULL, "Default");
    TreeView->Items->Item[0]->Data = pSetting;
    //[h R{{bNX̏
    int i = 0;
    while(1){
        const char *cszModule = KbSettingTimidity::GetModuleNameFromIndex(i);
        if(!cszModule){
            break;
        }
        ComboBox6->Items->Append(cszModule);
        i++;
    }
    //kbtim_xxx.kpi 
    WIN32_FIND_DATA fd;
    char szSearch[MAX_PATH*2];
    kbStrLCpy(szSearch, kbGetAppPath(), sizeof(szSearch));
    kbStrLCat(szSearch, "kbtim_*.kpi", sizeof(szSearch));
    HANDLE hFind = FindFirstFile(szSearch, &fd);
    if(hFind != INVALID_HANDLE_VALUE){
        int nCount = 0;
        do{
            if(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
                continue;
            }
            pSetting = new KbSettingTimidity;
            //kbtim_xxx.kpi ̃ev[g xxx
            //fd.cFileName + strlen("kbtim_") ɑ΂Ċgq΃ev[g
            //strlen("kbtim_") == 6;
            kbExtractReplacedFileExt(pSetting->szTemplateName, fd.cFileName + 6, "");

            TreeView->Items->Add(NULL, pSetting->szTemplateName);
            TreeView->Items->Item[++nCount]->Data = pSetting;
        }while(FindNextFile(hFind, &fd));
    }
    m_bChanging = FALSE;
    DoCopyData(ParamStr(1).c_str());
}
//---------------------------------------------------------------------------
__fastcall TSetupForm::~TSetupForm(void)
{
    const int nCount = TreeView->Items->Count;
    int i;
    for(i = 0; i < nCount; i++){
        KbSettingTimidity *pSetting = (KbSettingTimidity*)TreeView->Items->Item[i]->Data;
        TreeView->Items->Item[i]->Data = NULL;
        delete pSetting;
    }
}
//---------------------------------------------------------------------------
void __fastcall TSetupForm::EditChange(TObject *Sender)
{
    if(m_bChanging){
        return;
    }
    if(!m_bModified && Sender){
        m_bModified = TRUE;
        btnApply->Enabled = true;
        btnUndo->Enabled = true;
    }
    if(!Sender || (Sender == ComboBox1)){//o[u
        CheckBox11->Enabled = (ComboBox1->ItemIndex != 0);
        Edit1->Enabled = CheckBox11->Enabled;
    }
    if(!Sender || (Sender == ComboBox2)){//R[X
        CheckBox12->Enabled = (ComboBox2->ItemIndex == 1);
        Edit2->Enabled = CheckBox12->Enabled;
    }
    if(!Sender || (Sender == CheckBox16)){//L&R fBC
        BOOL bEnabled = CheckBox16->Checked;
        RadioButton1->Enabled = bEnabled;
        RadioButton2->Enabled = bEnabled;
        RadioButton3->Enabled = bEnabled;
        Label5->Enabled = bEnabled;
        Edit4->Enabled = bEnabled;
    }
}
//---------------------------------------------------------------------------
BOOL __fastcall TSetupForm::Apply(TTreeNode *pNode)
{
    if(!pNode){
        return FALSE;
    }

    const BOOL bIsDefault = (pNode == TreeView->Items->Item[0]);
    KbSettingTimidity *pSetting = (KbSettingTimidity*)pNode->Data;
    KbSettingTimidity setting;
    memcpy(&setting, pSetting, sizeof(KbSettingTimidity));
    
    kbStrLCpy(setting.szTemplateName, Edit->Text.c_str(), sizeof(setting.szTemplateName));
    kbStrLCpy(setting.ConfigFile, Memo->Text.c_str(), sizeof(setting.ConfigFile));
    kbStrTrim(kbCRLFtoSpace(setting.szTemplateName));
    kbStrTrim(kbCRLFtoSpace(setting.ConfigFile));
    int nReverbType = ComboBox1->ItemIndex;
    int nReverbLevel = 0;
    if(nReverbType > 0 &&
       CheckBox11->Checked){
        nReverbLevel = kbStrToIntDef(Edit1->Text.c_str(), 1);
    }
    setting.SetReverbLevel(nReverbType, nReverbLevel);

    int nChorusType = ComboBox2->ItemIndex;
    int nChorusLevel = 0;
    if(//nChorusType == 1 &&
       CheckBox12->Checked){
        nChorusLevel = kbStrToIntDef(Edit2->Text.c_str(), 1);
    }
    setting.SetChorusLevel(nChorusType, nChorusLevel);

    setting.opt_delay_control =  ComboBox3->ItemIndex;
    setting.opt_lpf_def =    ComboBox4->ItemIndex;
    setting.noise_sharp_type = kbStrToIntDef(Edit3->Text.c_str(), g_noise_sharp_type_default);
    {//L&R fBC
        int nLRDelayMode = -1;
        if(CheckBox16->Checked){
            if(RadioButton1->Checked){
                nLRDelayMode = 0;
            }
            else if(RadioButton2->Checked){
                nLRDelayMode = 1;
            }
            else{
                nLRDelayMode = 2;
            }
        }
        int nLRDelayMS = kbStrToIntDef(Edit4->Text.c_str(), g_effect_lr_delay_msec_default);
        setting.SetLRDelay(nLRDelayMode, nLRDelayMS);
    }
    setting.modify_release = kbStrToIntDef(Edit5->Text.c_str(), g_modify_release_default);
    setting.voices = kbStrToIntDef(Edit6->Text.c_str(), g_voices_default);
    setting.amplification = kbStrToIntDef(Edit7->Text.c_str(), g_amplification_default);
    setting.control_ratio = kbStrToIntDef(Edit8->Text.c_str(), g_control_ratio_default);
    setting.opt_drum_power = kbStrToIntDef(Edit9->Text.c_str(), g_opt_drum_power_default);
    setting.opt_default_module = KbSettingTimidity::GetModuleFromIndex(ComboBox6->ItemIndex);
    //ftHgKi
    if(RadioButton5->Checked){
        setting.opt_default_mid = 0x41;//GS
    }
    else if(RadioButton6->Checked){
        setting.opt_default_mid = 0x43;//XG
    }
    else{
        setting.opt_default_mid = 0x7e;//GM
    }
    int i;
    for(i = 0; i < sizeof(setting.b); i++){
        char szCheckBox[16];
        wsprintf(szCheckBox, "CheckBox%d", i+1);
        TCheckBox *cb = dynamic_cast<TCheckBox*>(FindComponent(szCheckBox));
        if(cb){
            setting.bBoolValues[i] = cb->Checked;
        }
    }
    setting.resample_type = ComboBox5->ItemIndex;
    setting.DoCheckParameter();
    //ev[gǂׂ
    if(!bIsDefault &&
       !CheckTemplateName(setting.szTemplateName)){
        return FALSE;
    }
    const int nCount = TreeView->Items->Count;
    for(i = 0; i < nCount; i++){
    //ev[g̏d`FbN
        KbSettingTimidity *pSettingI = (KbSettingTimidity*)TreeView->Items->Item[i]->Data;
        if(pSettingI != pSetting &&
           kbStrCmpI(setting.szTemplateName, pSettingI->szTemplateName) == 0){
            Application->MessageBox("ev[gdĂ܂B", "G[", MB_OK);
            return FALSE;
        }
    }
    char szIniFileName[MAX_PATH*2];
    GetIniFileNameFromTemplateName(setting.szTemplateName, szIniFileName, sizeof(szIniFileName));
    if(szIniFileName[0]){
        //INI ɕۑ
        char szOldIniFileName[MAX_PATH*2];
        GetIniFileNameFromTemplateName(pSetting->szTemplateName, szOldIniFileName, sizeof(szIniFileName));

        if(kbStrCmpI(szOldIniFileName, szIniFileName) != 0){
        //ev[gύXĂ
        //Â kbtim_templatename.ini/kpi 폜
            if(kbFileExists(szOldIniFileName)){
                if(!DeleteFile(szOldIniFileName)){//Â INI ̍폜
                    char sz[1024];
                    wsprintf(sz, "\"%s\" 폜o܂B\r\n"
                                 "ev[g̕ύXKpo܂łB", szOldIniFileName);
                    Application->MessageBox(sz, "G[", MB_OK);
                    return FALSE;
                }
            }
            kbExtractReplacedFileExt(szIniFileName, szOldIniFileName, ".kpi");
            if(kbFileExists(szIniFileName)){
                if(!DeleteFile(szIniFileName)){
                    WriteSetting(pSetting);//ݒ𕜌
                    char sz[1024];
                    wsprintf(sz, "\"%s\" 폜o܂B\r\n"
                                 "KbMedia Player gp̉\܂B\r\n"
                                 "ev[g̕ύXKpo܂łB", szIniFileName);
                    Application->MessageBox(sz, "G[", MB_OK);
                    return FALSE;
                }
            }
            m_bModified2 = TRUE;
        }
        else if(pSetting->bNew){
            m_bModified2 = TRUE;
        }
        WriteSetting(&setting);
        memcpy(pSetting, &setting, sizeof(KbSettingTimidity));
    }
    TreeViewChange(NULL, pNode);
    char szKbTim[MAX_PATH*2+16];
    kbStrLCpy(szKbTim, kbGetAppPath(), MAX_PATH*2);
    lstrcat(szKbTim, "kbtim.kpi");
    if(kbFileExists(szKbTim)){
        //t@CXVĂ̂ɊւẮA
        //V kbtim_templatename.kpi 쐬
        FILETIME ftKbTim;
        kbGetFileTimeFromFileName(szKbTim, &ftKbTim);
        for(i = nCount; i > 0; i--){
            pSetting = (KbSettingTimidity*)TreeView->Items->Item[i-1]->Data;
            char szKbTimTemplate[MAX_PATH*2];
            GetKpiFileNameFromTemplateName(pSetting->szTemplateName, szKbTimTemplate, sizeof(szKbTimTemplate));
            FILETIME ft;
            kbGetFileTimeFromFileName(szKbTimTemplate, &ft);
            if(CompareFileTime(&ftKbTim, &ft) != 0){
                CopyFile(szKbTim, szKbTimTemplate, FALSE);
            }
        }
    }
    btnApply->Enabled = false;
    btnUndo->Enabled = false;
    m_bModified = FALSE;
    return TRUE;
}
BOOL __fastcall TSetupForm::CheckModified2(void)
{
    if(m_bModified2){
    //ev[g̒ǉE폜E̕ύXĂ TRUE Ԃ
    //AKbMedia Player 삵ĂȂꍇ FALSE Ԃ
    //ev[g̒ǉE폜E̕ύXĂꍇAݒ̕ύX
    //f̂ KbMedia Player {̂ċNɂȂ
    //̊֐Ă΂ꂽ_ KbMedia Player NĂȂAċN𑣂
    //bZ[W\ׂANĂȂȂ炻̕Kv͂Ȃ̂ŁA
    //FALSE Ԃ悤ɂĂ\Ȃ
        HANDLE hMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, "KbMedia Player");
        if(!hMutex){
            m_bModified2 = FALSE;
        }
        else{
            CloseHandle(hMutex);
        }
    }
    return m_bModified2;
}
BOOL __fastcall TSetupForm::Delete(TTreeNode *pNode)
{
    if(!pNode)return FALSE;
    if(pNode == TreeView->Items->Item[0]){
        return FALSE;
    }
    KbSettingTimidity *pSetting = (KbSettingTimidity*)pNode->Data;
    char szIniFileName[MAX_PATH*2];
    GetIniFileNameFromTemplateName(pSetting->szTemplateName, szIniFileName, sizeof(szIniFileName));
    if(szIniFileName[0]){
        if(kbFileExists(szIniFileName)){
            if(!DeleteFile(szIniFileName)){
                return FALSE;
            }
        }
        char szKpiFileName[MAX_PATH*2];
        kbExtractReplacedFileExt(szKpiFileName, szIniFileName, ".kpi");
        if(kbFileExists(szKpiFileName)){
            if(!DeleteFile(szKpiFileName)){
                WriteSetting(pSetting);
                char szMes[1024];
                wsprintf(szMes, "%s \r\n\r\n폜o܂B\r\n"
                                "KbMedia Player gp̉\܂B\r\n"
                                "ev[g \"%s\" 폜o܂łB\r\n"
                                , szKpiFileName, pSetting->szTemplateName);
                Application->MessageBox(szMes, "G[", MB_OK);
                return FALSE;
            }
        }
    }
    pNode->Data = NULL;
    delete pSetting;
    pNode->Delete();
    m_bModified2 = TRUE;
    return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TSetupForm::TreeViewChanging(TObject *Sender,
      TTreeNode *Node, bool &AllowChange)
{
    if(m_bModified){
        char szMes[1024];
        TTreeNode *Sel = TreeView->Selected;
        if(Sel){
            wsprintf(szMes, "%s ւ̕ύXۑ܂H", (char*)((KbSettingTimidity*)Sel->Data)->szTemplateName);
            int ret = Application->MessageBox(szMes, "", MB_YESNOCANCEL|MB_DEFBUTTON3);
            if(ret == IDYES){
                if(Apply(Sel)){
                    AllowChange = true;
                }
            }
            else if(ret == IDNO){
                AllowChange = true;
            }
            else if(ret == IDCANCEL){
                AllowChange = false;
            }
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TSetupForm::UpdateGUI(KbSettingTimidity *pSetting, TTreeNode *pNode)
{//pSetting ̐ݒɏ]ĉʂ\
    m_bChanging = TRUE;
    pSetting->DoCheckParameter();

    Edit->Text = kbStrTrim(kbCRLFtoSpace(pSetting->szTemplateName));
    Memo->Text = kbStrTrim(kbCRLFtoSpace(pSetting->ConfigFile));

    int i;
    int nReverbType, nReverbLevel;
    int nChorusType, nChorusLevel;

    pSetting->GetReverbLevel(&nReverbType, &nReverbLevel);
    pSetting->GetChorusLevel(&nChorusType, &nChorusLevel);
    ComboBox1->ItemIndex = nReverbType;
    ComboBox2->ItemIndex = nChorusType;
    ComboBox3->ItemIndex = pSetting->opt_delay_control;
    ComboBox4->ItemIndex = pSetting->opt_lpf_def;
    ComboBox5->ItemIndex = pSetting->resample_type;
    ComboBox6->ItemIndex = KbSettingTimidity::GetIndexFromModule(pSetting->opt_default_module);
    Edit1->Text = nReverbLevel;
    Edit2->Text = nChorusLevel;
    Edit3->Text = pSetting->noise_sharp_type;
    Edit4->Text = pSetting->effect_lr_delay_msec;
    Edit5->Text = pSetting->modify_release;
    Edit6->Text = pSetting->voices;
    Edit7->Text = pSetting->amplification;
    Edit8->Text = pSetting->control_ratio;
    Edit9->Text = pSetting->opt_drum_power;
    int effect_lr_mode = pSetting->effect_lr_mode;
    TRadioButton *rbs[] = {RadioButton1, RadioButton2, RadioButton3};
    CheckBox16->Checked = (effect_lr_mode >= 0);
    for(i = 0; i < 3; i++){
        bool bChecked = (i == effect_lr_mode);
        if(effect_lr_mode < 0 && i == 2){
            bChecked = true;
        }
        rbs[i]->Checked = bChecked;
    }
    for(i = 0; i < sizeof(pSetting->b); i++){
        char szCheckBoxName[64];
        wsprintf(szCheckBoxName, "CheckBox%d", i+1);
        TCheckBox *cb = dynamic_cast<TCheckBox*>(FindComponent(szCheckBoxName));
        if(cb){
            cb->Checked = pSetting->bBoolValues[i];
        }
    }
    //ftHgKi
    switch(pSetting->opt_default_mid){
        case 0x41: //GS
            RadioButton5->Checked = true;
            break;
        case 0x43: //XG
            RadioButton6->Checked = true;
            break;
        default:   //GM
            RadioButton4->Checked = true;
            break;
    }
    char szKpiFileName[MAX_PATH*2];
    GetKpiFileNameFromTemplateName(pSetting->szTemplateName, szKpiFileName, sizeof(szKpiFileName));
    Label2->Caption = szKpiFileName;
    pNode->Text = pSetting->szTemplateName;
    m_bChanging = FALSE;

    EditChange(NULL);
}
void __fastcall TSetupForm::TreeViewChange(TObject *Sender, TTreeNode *pNode)
{
    KbSettingTimidity *pSetting = (KbSettingTimidity*)pNode->Data;
    if(!pSetting){
        return;
    }
    ReadSetting(pSetting);
    UpdateGUI(pSetting, pNode);

    btnApply->Enabled = false;
    btnUndo->Enabled = false;
    BOOL bIsDefault = (pNode == TreeView->Items->Item[0]);
    btnDel->Enabled = !bIsDefault;
    Edit->Enabled = !bIsDefault;
    btnAutoDef->Enabled = !bIsDefault;
    m_bModified = FALSE;
}
//---------------------------------------------------------------------------
void __fastcall TSetupForm::btnClick(TObject *Sender)
{
    if(Sender == btnCfg){//.CFG File
        if(OpenDialog->Execute()){
            Memo->Text = OpenDialog->FileName;
            EditChange(Sender);
        }
    }
    else if(Sender == btnEdit){//ҏW
        char szPath[MAX_PATH*2];
        kbStrLCpy(szPath, Memo->Text.c_str(), sizeof(szPath));
        ExecExplorer(szPath);
    }
    else if(Sender == btnNew){//VK쐬
        char szNewTemplateName[256];
        kbStrLCpy(szNewTemplateName, "Template01", sizeof(szNewTemplateName));
        const int nCount = TreeView->Items->Count;
        int t = 1;
        int i = 1;
        while(i < nCount){
            KbSettingTimidity *setting = (KbSettingTimidity*)TreeView->Items->Item[i]->Data;
            if(kbStrCmpI(setting->szTemplateName, szNewTemplateName) == 0){
                if(nCount > 32){
                    return;
                }
                wsprintf(szNewTemplateName, "Template%02d", ++t);
                i = 1;
                continue;
            }
            i++;
        }
        TTreeNode *pNode = TreeView->Items->Add(NULL, szNewTemplateName);
        KbSettingTimidity *pSetting = new KbSettingTimidity;
        kbStrLCpy(pSetting->szTemplateName, szNewTemplateName, sizeof(pSetting->szTemplateName));
        pNode->Data = pSetting;
        TreeView->Selected = pNode;
        pSetting->bNew = TRUE;
    }
    else if(Sender == btnApply){//Kp
        Apply(TreeView->Selected);
    }
    else if(Sender == btnUndo){//ɖ߂
        TTreeNode *pNode = TreeView->Selected;
        if(pNode){
            TreeViewChange(NULL, pNode);
        }
    }
    else if(Sender == btnDefault){//ݒɖ߂
        TTreeNode *pNode = TreeView->Selected;
        if(pNode){
            KbSettingTimidity *pSetting = (KbSettingTimidity*)pNode->Data;
            KbSettingTimidity DefaultSetting;//RXgN^ŏݒɂȂĂ
            kbStrLCpy(DefaultSetting.szTemplateName, pSetting->szTemplateName, sizeof(DefaultSetting.szTemplateName));
            kbStrLCpy(DefaultSetting.ConfigFile, pSetting->ConfigFile, sizeof(DefaultSetting.ConfigFile));
            UpdateGUI(&DefaultSetting, pNode);
            EditChange(Sender);
        }
    }
    else if(Sender == btnDel){//폜
        char szMes[1024];
        wsprintf(szMes, "\"%s\" 폜Ă낵łH\r\n"
                        "̑͌ɖ߂܂B",
                    (char*)((KbSettingTimidity*)TreeView->Selected->Data)->szTemplateName);
        int ret = Application->MessageBox(szMes, "mF", MB_YESNO|MB_DEFBUTTON2);
        if(ret == IDYES){
            Delete(TreeView->Selected);
        }
    }
    else if(Sender == btnAutoLQ){//ቹᕉ
        TTreeNode *pNode = TreeView->Selected;
        if(pNode){
            KbSettingTimidity setting;
            //IɎw肵Ȃ̂̓ftHglɖ߂
            setting.opt_reverb_control = 0;
            setting.opt_chorus_control = 0;
            setting.opt_surround_chorus = 0;
            setting.opt_delay_control = 0;
            setting.opt_lpf_def = 0;
            setting.noise_sharp_type = 0;
            setting.voices = 128;
            setting.amplification = g_amplification_default;
            setting.control_ratio = g_control_ratio_default;
            setting.effect_lr_mode = -1;
            setting.effect_lr_delay_msec = g_effect_lr_delay_msec_default;
            setting.resample_type = RESAMPLE_NONE;

            setting.b.opt_modulation_wheel = false;
            setting.b.opt_portamento = false;
            setting.b.opt_channel_pressure = false;
            setting.b.opt_drum_effect = false;
            setting.b.opt_nrpn_vibrato = false;
            setting.b.opt_tva_attack = false;
            setting.b.opt_tva_decay = false;
            setting.b.opt_tva_release = false;
            setting.b.opt_eq_control = false;
            setting.b.opt_insertion_effect = false;

            setting.b.opt_overlap_voice_allow = false;
            setting.b.opt_modulation_envelope = false;
            setting.b.opt_pan_delay = false;

            setting.b.antialiasing_allowed = false;
            setting.b.opt_realtime_playing = false;
            setting.b.free_instruments_afterwards = false;

            kbStrLCpy(setting.szTemplateName, Edit->Text.c_str(), sizeof(setting.szTemplateName));
            kbStrLCpy(setting.ConfigFile, Memo->Text.c_str(), sizeof(setting.ConfigFile));
            UpdateGUI(&setting, pNode);
            EditChange(Sender);
        }
    }
    else if(Sender == btnAutoHQ){//
        TTreeNode *pNode = TreeView->Selected;
        if(pNode){
            KbSettingTimidity setting;
            //IɎw肵Ȃ̂̓ftHglɖ߂
            setting.opt_reverb_control = 3;
            setting.opt_chorus_control = 0;
            setting.opt_surround_chorus = 1;
            setting.opt_delay_control = 1;
            setting.opt_lpf_def = g_opt_lpf_def_default;
            setting.noise_sharp_type = 4;
            setting.voices = 512;
            setting.amplification = g_amplification_default-10;//ꂵ₷̂ŏ
            setting.control_ratio = g_control_ratio_default;
            setting.effect_lr_mode = -1;
            setting.effect_lr_delay_msec = g_effect_lr_delay_msec_default;
            setting.resample_type = RESAMPLE_GAUSS;

            setting.b.opt_modulation_wheel = true;
            setting.b.opt_portamento = true;
            setting.b.opt_channel_pressure = true;
            setting.b.opt_drum_effect = true;
            setting.b.opt_nrpn_vibrato = true;
            setting.b.opt_tva_attack = true;
            setting.b.opt_tva_decay = true;
            setting.b.opt_tva_release = true;
            setting.b.opt_eq_control = true;
            setting.b.opt_insertion_effect = false;

            setting.b.opt_overlap_voice_allow = true;
            setting.b.opt_modulation_envelope = true;
            setting.b.opt_pan_delay = true;
            setting.b.antialiasing_allowed = true;
            setting.b.opt_realtime_playing = true;
            setting.b.free_instruments_afterwards = true;

            kbStrLCpy(setting.szTemplateName, Edit->Text.c_str(), sizeof(setting.szTemplateName));
            kbStrLCpy(setting.ConfigFile, Memo->Text.c_str(), sizeof(setting.ConfigFile));
            UpdateGUI(&setting, pNode);
            EditChange(Sender);
        }
    }
    else if(Sender == btnAutoDef){//Default Ɠ
        TTreeNode *pNode = TreeView->Selected;
        if(pNode){
            KbSettingTimidity *pDataDefault = (KbSettingTimidity*)(TreeView->Items->Item[0]->Data);
            KbSettingTimidity setting;
            ReadSetting(pDataDefault);
            memcpy(&setting, pDataDefault, sizeof(KbSettingTimidity));
            kbStrLCpy(setting.szTemplateName, Edit->Text.c_str(), sizeof(setting.szTemplateName));
            kbStrLCpy(setting.ConfigFile, Memo->Text.c_str(), sizeof(setting.ConfigFile));
            UpdateGUI(&setting, pNode);
            EditChange(Sender);
        }
    }
    else if(Sender == btnDefAll){//ׂDefaultƓ
        const int nCount = TreeView->Items->Count;
        if(nCount < 2){
            return;
        }
        char szMes[1024];
        kbStrLCpy(szMes, "SẴev[g̐ݒ \"Default\" ̐ݒƓĂ낵łH\r\n"
                         "̑͌ɖ߂܂B", sizeof(szMes));
        int ret = Application->MessageBox(szMes, "mF", MB_YESNO|MB_DEFBUTTON2);
        if(ret == IDYES){
            int i;
            KbSettingTimidity *pDataDefault = (KbSettingTimidity*)(TreeView->Items->Item[0]->Data);
            ReadSetting(pDataDefault);
            for(i = nCount - 1; i > 0; i--){
                KbSettingTimidity setting;
                memcpy(&setting, pDataDefault, sizeof(KbSettingTimidity));
                KbSettingTimidity *pSetting = (KbSettingTimidity*)(TreeView->Items->Item[i]->Data);
                ReadSetting(pSetting);
                kbStrLCpy(setting.szTemplateName, pSetting->szTemplateName, sizeof(setting.szTemplateName));
                kbStrLCpy(setting.ConfigFile, pSetting->ConfigFile, sizeof(setting.ConfigFile));
                memcpy(pSetting, &setting, sizeof(KbSettingTimidity));
                WriteSetting(pSetting);
            }
            TTreeNode *pNodeSelected = TreeView->Selected;
            if(pNodeSelected){
                KbSettingTimidity *pDataSelected = (KbSettingTimidity*)pNodeSelected->Data;
                UpdateGUI(pDataSelected, pNodeSelected);
                btnApply->Enabled = false;
                btnUndo->Enabled = false;
                m_bModified = FALSE;
            }
        }
    }
    else if(Sender == btnOK){//OK
        TTreeNode *pNode = TreeView->Selected;
        if(pNode){
            if(Apply(pNode)){
                Close();
            }
        }
        else{
            Close();
        }
    }
    else if(Sender == btnCancel){//LZ
        Close();
    }
    else if(Sender == btnHelp){//wv
    }
    if(CheckModified2()){
        m_bModified2 = FALSE;
        Application->MessageBox("ev[gǉE폜܂͖̕ύX܂B\r\n"
                                "ݒ̕ύX𔽉fɂ́A\r\n"
                                "Eu\vj[uŐV̏ɍXVvs\r\n"
                                "EKbMedia Player ċN\r\n"
                                "̂ꂩsKv܂B",
                                "kbtim ݒ", MB_OK);
    }
}
void __fastcall TSetupForm::WMCopyData(TMessage &Message)
{
    COPYDATASTRUCT *cds = (COPYDATASTRUCT *)Message.LParam;
    if(cds && cds->lpData){
        DoCopyData((const char*)cds->lpData);
    }
}
//---------------------------------------------------------------------------
void __fastcall TSetupForm::DoCopyData(const char *cszCommand)
{
    static BOOL bReenterChecker = FALSE;
    if(bReenterChecker){//ēh~
        return;
    }
    const char *cszKpi = cszCommand;
    bReenterChecker = TRUE;
    if(cszKpi && *cszKpi){
        char szTmpFileName[MAX_PATH*2];
        const int nCount = TreeView->Items->Count;
        int i;
        for(i = 0; i < nCount; i++){
            KbSettingTimidity *pSetting = (KbSettingTimidity*)TreeView->Items->Item[i]->Data;
            GetKpiFileNameFromTemplateName(pSetting->szTemplateName, szTmpFileName, sizeof(szTmpFileName));
            if(kbStrCmpI(cszKpi, szTmpFileName) == 0){
                TreeView->Items->Item[i]->Selected = true;
                break;
            }
        }
    }
    else{
        TreeView->Items->Item[0]->Selected = true;
    }
    bReenterChecker = FALSE;
}





